/**
 * CR2.java
 *
 * File generated from the medication2::CR2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class CR2.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CR", propOrder = {
	"name",
	"value",
	"inverted"
})
@XmlRootElement(name = "CR2")
public class CR2 extends net.ihe.gazelle.medication2.ANY2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          Specifies the manner in which
	                                the concept role value                         contributes to the
	                                meaning of a code phrase.  For                         example, if
	                                SNOMED RT defines a concept "leg", a role
	                                relation "has-laterality", and another concept "left",
	                                the concept role relation allows to add the qualifier
	                                "has-laterality: left" to a primary code "leg" to
	                                construct the meaning "left leg".  In this example
	                                "has-laterality" is the CR.name.
	                            .
	 */
	@XmlElement(name = "name", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.CV2 name;
	/**
	 *                          The concept that modifies the
	                                primary code of a code                         phrase through the
	                                role relation.  For example, if                         SNOMED RT
	                                defines a concept "leg", a role relation
	                                "has-laterality", and another concept "left", the
	                                concept role relation allows adding the qualifier
	                                "has-laterality: left" to a primary code "leg" to
	                                construct the meaning "left leg".  In this example
	                                "left" is the CR.value.                      .
	 */
	@XmlElement(name = "value", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.CD2 value;
	/**
	 *                       Indicates if the sense of the role
	                            name is inverted.                      This can be used in cases where
	                            the underlying code                      system defines inversion but
	                            does not provide reciprocal                      pairs of role names. By
	                            default, inverted is false.                   .
	 */
	@XmlAttribute(name = "inverted")
	public java.lang.Boolean inverted;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return name.
	 * @return name :                          Specifies the manner in which
	                                the concept role value                         contributes to the
	                                meaning of a code phrase.  For                         example, if
	                                SNOMED RT defines a concept "leg", a role
	                                relation "has-laterality", and another concept "left",
	                                the concept role relation allows to add the qualifier
	                                "has-laterality: left" to a primary code "leg" to
	                                construct the meaning "left leg".  In this example
	                                "has-laterality" is the CR.name.
	                            
	 */
	public net.ihe.gazelle.medication2.CV2 getName() {
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name :                          Specifies the manner in which
	                                the concept role value                         contributes to the
	                                meaning of a code phrase.  For                         example, if
	                                SNOMED RT defines a concept "leg", a role
	                                relation "has-laterality", and another concept "left",
	                                the concept role relation allows to add the qualifier
	                                "has-laterality: left" to a primary code "leg" to
	                                construct the meaning "left leg".  In this example
	                                "has-laterality" is the CR.name.
	                            .
	 */
	public void setName(net.ihe.gazelle.medication2.CV2 name) {
	    this.name = name;
	}
	
	
	
	
	/**
	 * Return value.
	 * @return value :                          The concept that modifies the
	                                primary code of a code                         phrase through the
	                                role relation.  For example, if                         SNOMED RT
	                                defines a concept "leg", a role relation
	                                "has-laterality", and another concept "left", the
	                                concept role relation allows adding the qualifier
	                                "has-laterality: left" to a primary code "leg" to
	                                construct the meaning "left leg".  In this example
	                                "left" is the CR.value.                      
	 */
	public net.ihe.gazelle.medication2.CD2 getValue() {
	    return value;
	}
	
	/**
	 * Set a value to attribute value.
	 * @param value :                          The concept that modifies the
	                                primary code of a code                         phrase through the
	                                role relation.  For example, if                         SNOMED RT
	                                defines a concept "leg", a role relation
	                                "has-laterality", and another concept "left", the
	                                concept role relation allows adding the qualifier
	                                "has-laterality: left" to a primary code "leg" to
	                                construct the meaning "left leg".  In this example
	                                "left" is the CR.value.                      .
	 */
	public void setValue(net.ihe.gazelle.medication2.CD2 value) {
	    this.value = value;
	}
	
	
	
	
	/**
	 * Return inverted.
	 * @return inverted :                       Indicates if the sense of the role
	                            name is inverted.                      This can be used in cases where
	                            the underlying code                      system defines inversion but
	                            does not provide reciprocal                      pairs of role names. By
	                            default, inverted is false.                   
	 */
	public java.lang.Boolean getInverted() {
	    return inverted;
	}
	
	/**
	 * Set a value to attribute inverted.
	 * @param inverted :                       Indicates if the sense of the role
	                            name is inverted.                      This can be used in cases where
	                            the underlying code                      system defines inversion but
	                            does not provide reciprocal                      pairs of role names. By
	                            default, inverted is false.                   .
	 */
	public void setInverted(java.lang.Boolean inverted) {
	    this.inverted = inverted;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "CR2").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(CR2 cR2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (cR2 != null){
   			net.ihe.gazelle.medication2.ANY2.validateByModule(cR2, _location, cvm, diagnostic);
			net.ihe.gazelle.medication2.CV2.validateByModule(cR2.getName(), _location + "/name", cvm, diagnostic);
			net.ihe.gazelle.medication2.CD2.validateByModule(cR2.getValue(), _location + "/value", cvm, diagnostic);
    	}
    }

}
